Subject: Re: linux-next: manual merge of the block tree with the asm-generic tree

From: Ingo Molnar <[email-masked]>
Date: Wed, 11 Oct 2023 23:32:54 +0200

* Peter Zijlstra <[email-masked]> wrote:

> On Wed, Oct 11, 2023 at 10:21:06AM -0600, Jens Axboe wrote:
> > On 10/9/23 8:16 AM, Jens Axboe wrote:
> > > On 10/9/23 8:13 AM, Peter Zijlstra wrote:
> > >> On Mon, Oct 09, 2023 at 11:00:19AM +0200, Arnd Bergmann wrote:
> > >>> On Mon, Oct 9, 2023, at 10:48, Peter Zijlstra wrote:
> > >>>> On Mon, Oct 09, 2023 at 12:31:18PM +1100, Stephen Rothwell wrote:
> > >>>>> diff --cc arch/alpha/kernel/syscalls/syscall.tbl
> > >>>>> index 5d05ab716a74,b1865f9bb31e..000000000000
> > >>>>> --- a/arch/alpha/kernel/syscalls/syscall.tbl
> > >>>>> +++ b/arch/alpha/kernel/syscalls/syscall.tbl
> > >>>>> @@@ -492,4 -492,6 +492,7 @@@
> > >>>>>   560	common	set_mempolicy_home_node		sys_ni_syscall
> > >>>>>   561	common	cachestat			sys_cachestat
> > >>>>>   562	common	fchmodat2			sys_fchmodat2
> > >>>>>  -563	common	futex_wake			sys_futex_wake
> > >>>>>  -564	common	futex_wait			sys_futex_wait
> > >>>>>  -565	common	futex_requeue			sys_futex_requeue
> > >>>>>  +563	common	map_shadow_stack		sys_map_shadow_stack
> > >>>>> ++564	common	futex_wake			sys_futex_wake
> > >>>>> ++565	common	futex_wait			sys_futex_wait
> > >>>>> ++566	common	futex_requeue			sys_futex_requeue
> > >>>>
> > >>>> So this renumbers the (futex) stuff on Alpha, does anybody care? AFAICT
> > >>>> Alpha does not follow the unistd order and meh.
> > >>>
> > >>> Let's not make it worse for now. All the numbers since the
> > >>> introduction of the time64 syscalls are offset by exactly 120
> > >>> on alpha, and I'd prefer to keep it that way for the moment.
> > >>>
> > >>> I still hope to eventually finish the conversion of all architectures
> > >>> to a single syscall.tbl for numbers >400, and if that happens before
> > >>> the end of alpha, a different ordering would just be extra pain.
> > >>
> > >> Fair enough; should we look at rebase those futex patches for this? (bit
> > >> of a pain as that would also mean rebasing block)
> > > 
> > > From my point of view, this isn't a huge problem if we do it now. The
> > > io_uring-futex branch is a separate branch and I have nothing on top of
> > > it, so I could easily just re-pull your updated branch and rebase my
> > > changes on top.
> > > 
> > >> Or do we want to keep this fixup in the merge resolution and make sure
> > >> Linus is aware?
> > > 
> > > If you're OK with it, I'd say let's rebase and save ourselves the
> > > trouble at merge time.
> > 
> > Peter, what's the verdict - do you want to rebase it, or leave it as-is?
> 
> Ah, I looked into doing this, but tip/locking/core has since grown a
> bunch of patches and has a merge commit -- I talked to Ingo yesterday
> and he proposed just queueing a fix on top instead of doing a full
> rebase.
> 
> Ingo, that still your preferred solution?

Yeah, that would be the best solution IMO - it's not like there's any real 
prospect of someone bisecting futex2 patch-enablement commits on Alpha ... 
and the bisection distance isn't particularly large either in any case.

[ This would also document the very real historic conflict between these 
  numbers, as it happened. ]

Thanks,

	Ingo